/****************************
*
*    ʹ޹ص
*
****************************/

#include <windows.h>
#include "Functions.h"

static OPENFILENAME ofn;

//ʼͨöԻ
void Initialize(HWND hwnd, HINSTANCE hInstance)
{
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwnd;
	ofn.hInstance = hInstance;
	ofn.nMaxFile = MAX_PATH;
}

//ļԻ
BOOL OpenFileDlg(LPSTR pstrFile, LPCSTR szFilter, LPCSTR szDefExt)
{
	ofn.lpstrFile = pstrFile;
	pstrFile[0] = '\0';
	ofn.lpstrFilter = szFilter;
	ofn.lpstrDefExt = szDefExt;
	ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;

	return GetOpenFileName(&ofn);
}

//ļԻ
BOOL SaveFileDlg(LPSTR pstrFile, LPCSTR szFilter, LPCSTR szDefExt)
{
	ofn.lpstrFile = pstrFile;
	pstrFile[0] = '\0';
	ofn.lpstrFilter = szFilter;
	ofn.lpstrDefExt = szDefExt;
	ofn.Flags = OFN_OVERWRITEPROMPT;

	return GetSaveFileName(&ofn);
}


//ڴDCʼ
MDC::MDC()
{
	ZeroMemory(&info, sizeof(info));
	info.bmiHeader.biSize = sizeof(info.bmiHeader);
	info.bmiHeader.biBitCount = 32;
	info.bmiHeader.biPlanes = 1;
}

//ڴDC
MDC::~MDC()
{
	Destroy();
}

//ڴDC
void MDC::Create(int nWidth, int nHeight)
{
	Destroy();
	hdc = CreateCompatibleDC(NULL);

	info.bmiHeader.biWidth = nWidth;
	info.bmiHeader.biHeight = nHeight;
	info.bmiHeader.biSizeImage = 4 * nWidth * nHeight;
	hBitmap = CreateDIBSection(hdc, &info, DIB_RGB_COLORS, (void**)&Data, NULL, 0);

	OldBitmap = (HBITMAP)SelectObject(hdc, hBitmap);
}

//ڴDC
void MDC::Destroy()
{
	if(hdc)
	{
		SelectObject(hdc, OldBitmap);
		DeleteObject(hBitmap);
		DeleteDC(hdc);
		hBitmap = NULL;
		hdc = NULL;
	}
}

#include <cstdio>

extern COLOR Colors[1000];//ɫ
extern byte ID[1000], Data[1000];//MCID,
extern int nColor;//ɫ

//ɫ
bool Input()
{
	FILE *f;
	f = fopen("Colors.txt", "r");
	if(!f) return FALSE;

	char str[100];
	int BlockId, BlockData, R, G, B;
	while(fgets(str, 100, f))
	{
		if(sscanf(str, "%d,%d,%d,%d,%d", &BlockId, &BlockData, &R, &G, &B) == 5)
		{
			ID[nColor] = BlockId;
			Data[nColor] = BlockData;
			Colors[nColor].byColor.A = 255;
			Colors[nColor].byColor.R = R;
			Colors[nColor].byColor.G = G;
			Colors[nColor++].byColor.B = B;
		}
	}
	fclose(f);
	return nColor > 0;
}

#include <math.h>
#define SQUARE(x) ((x) * (x))

//ȡɫ
double GetDistance(BYTE R1, BYTE G1, BYTE B1, BYTE R2, BYTE G2, BYTE B2)
{
	//RGBƽ
	return sqrt(SQUARE(R1 - R2) + SQUARE(G1 - G2) + SQUARE(B1 - B2));
}

//ȡɫ
int GetNearestColorIndex(COLOR ParamColor)
{
	int i, Index;//ǰ,ɫ
	double DST, min;//ɫ,Сɫ

	Index = 0;
	min = GetDistance(ParamColor.byColor.R, ParamColor.byColor.G, ParamColor.byColor.B,
		Colors[0].byColor.R, Colors[0].byColor.G, Colors[0].byColor.B);
	for(i = 1 ; i < nColor ; i++)
	{
		DST = GetDistance(ParamColor.byColor.R, ParamColor.byColor.G, ParamColor.byColor.B,
		Colors[i].byColor.R, Colors[i].byColor.G, Colors[i].byColor.B);
		if(DST < min)
		{
			min = DST;
			Index = i;
		}
	}
	return Index;
}
